#ifndef STOPWATCH_H
#define STOPWATCH_H

/*
  Kandis - A tea steepming timer.
  Copyright (C) 2007  Tim Teulings

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <Lum/Model/Action.h>

#include <Lum/OS/Font.h>

#include <Lum/Object.h>

class StopWatch : public Lum::Control
{
private:
  Lum::OS::FontRef      minFont;
  Lum::OS::FontRef      font;
  std::wstring          text;
  Lum::Model::ActionRef clickAction;
  Lum::OS::ColorRef     alarmColor;
  bool                  alarm;

public:
  StopWatch();

  Lum::Model::Action* GetClickAction() const;

  void SetText(const std::wstring& text);
  void SetAlarm(bool alarm);

  void CalcSize();

  Lum::OS::Font* FindFont();

  void Layout();
  void Draw(int x, int y, size_t w, size_t h);

  bool HandleMouseEvent(const Lum::OS::MouseEvent& event);
};

#endif
